//  Created by Monte Hurd on 11/22/14.
//  Copyright (c) 2014 Wikimedia Foundation. Provided under MIT-style license; please copy and modify!

#import "UITableView+DynamicCellHeight.h"

@implementation UITableView (DynamicCellHeight)

// Based on this insanity: http://stackoverflow.com/a/18746930/135557
// However, I think best practice is to re-use a single offscreen cell for size determination.
- (CGFloat)heightForSizingCell:(UITableViewCell*)cell {
    [cell setNeedsUpdateConstraints];
    [cell updateConstraintsIfNeeded];
    cell.bounds = CGRectMake(0.0f, 0.0f, CGRectGetWidth(self.bounds), CGRectGetHeight(cell.bounds));
    [cell setNeedsLayout];
    [cell layoutIfNeeded];
    return [cell.contentView systemLayoutSizeFittingSize:UILayoutFittingCompressedSize].height + 1.0f;
}

@end
